
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <windows.h>

typedef unsigned long int ULONG;
#define COUNT  (2*1024*1024)
#define NTIMES 25

void hash(ULONG * in, ULONG * out, ULONG * table)
{
   unsigned int vv = out[0] ;
   vv += in[0];
   vv *= table[0];
   vv = (vv >> 16) | (vv << 16);
   vv *= table[1];
   vv = (vv >> 16) | (vv << 16);
   vv *= table[2];
   vv = (vv >> 16) | (vv << 16);
   vv *= table[3];
   vv = (vv >> 16) | (vv << 16);
   vv *= table[4];
   vv += table[10];
   out[1] += vv;

   vv += in[1];
   vv *=  table[5];
   vv =  (vv >> 16) | (vv << 16);
   vv *= table[6];
   vv =  (vv >> 16) | (vv << 16);
   vv *= table[7];
   vv =  (vv >> 16) | (vv << 16);
   vv *= table[8];
   vv =  (vv >> 16) | (vv << 16);
   vv *= table[9];
   vv += table[11];
   out[1] += vv;
   out[0] = vv; 
}


void routine1(ULONG * buf, unsigned int count, 
            ULONG * out, ULONG * table)
{
    int i;
    ULONG * p = &buf[0];
    out[0] = 0;
    out[1] = 0;
    
    for (i = 0; i < count/8; i++)
    {
        hash(p,out, table);
        p+=2;
    }
}

ULONG randlong()
{
    return (rand() << 17)|(rand());
}

int main(int argc, char ** argv)
{
    int seed = 0;
    unsigned long int tStart, tEnd, tTotal = 0;
    unsigned long int tMin = -1, tMax = 0;
    int times = 0;
    ULONG * buf = malloc( COUNT * sizeof(ULONG));
    ULONG out1[2];
    ULONG out2[2];

    timeBeginPeriod(1);
    if (argc > 1)
    {
        seed = atoi(argv[1]);
        srand(seed);
    }
    else
    {
        int t = time(0);
        srand(t);
    }   
    
    for (times = 0; times < NTIMES ; times ++ )
    {
        ULONG   table[12];       
        ULONG   t;
        int     i;
        ULONG local_seed = seed;
        
        if (!seed)
        {
            local_seed = randlong();  
            printf("(% 3d of % 3d  Seed = %ld\n", times, NTIMES, local_seed);
        }
        srand(local_seed);
       
        for (i = 0; i < COUNT ; i++)
        {
            buf[i] = randlong();              
        }
        for (i = 0; i < 11; i++)
        {
            table[i] = randlong()|1;
        }

        for (i = 0; i < 12; i++)
        {
            printf("%08lx ",table[i]);
            if ((i&3)==3) printf("\n");
        }

        tStart = timeGetTime();
            routine1(buf, COUNT*sizeof(ULONG), out2, table);       
        tEnd = timeGetTime();
           
#if 0
        if ((out1[0] != out2[0]) || (out1[1] != out2[1]))
        {
            fprintf(stderr, "MISCOMPARE (%08lx, %08lx) (%08lx %08lx) "
                   " SEED %ld\n",
                out1[0],out1[1], out2[0], out2[1], local_seed); 
            exit(-1);
        }
#endif

        t = tEnd - tStart;
        if (t > tMax) tMax = t;
        if (t < tMin) tMin = t;
        tTotal += t;
   }
    printf("Avg Time: %f (%d...%d).\n", (float)tTotal/NTIMES, tMin,tMax);
    timeEndPeriod(1);
}

